VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmListView 
   Caption         =   "xxx"
   ClientHeight    =   6375
   ClientLeft      =   5085
   ClientTop       =   2595
   ClientWidth     =   9045
   LinkTopic       =   "Form1"
   ScaleHeight     =   6375
   ScaleWidth      =   9045
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   435
      Left            =   7830
      TabIndex        =   1
      Top             =   5850
      Width           =   1125
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   5715
      Left            =   60
      TabIndex        =   0
      Top             =   90
      Width           =   8925
      _ExtentX        =   15743
      _ExtentY        =   10081
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "frmListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_strFormName                  As String
Private m_vntData                      As Variant
Private m_vntOrder                     As Variant
Private m_vntHeaders                   As Variant

Public Sub Init(ByVal xi_strFormName As String, _
                ByVal xi_vntData As Variant, _
                ByVal xi_vntOrder As Variant, _
                ByVal xi_vntHeaders As Variant)
   
   m_strFormName = xi_strFormName
   m_vntData = xi_vntData
   m_vntOrder = xi_vntOrder
   m_vntHeaders = xi_vntHeaders
   
End Sub

Private Sub cmdClose_Click()
   Unload Me
End Sub

Private Sub Form_Load()
   Dim p_lngNumItems                   As Long
   Dim p_lngNumRows                    As Long
   Dim p_lngLoop                       As Long
   Dim p_lngInnerLoop                  As Long
   Dim p_lngRow                        As Long
   Dim p_lngCol                        As Long
   Dim p_lngColData                    As Long
   Dim p_strTmp                        As String
   Dim p_objListItem                   As ListItem
   
   modMain.CenterForm Me
   
   Me.Caption = m_strFormName
   
   InitListview
   
   ' ------------------------------------------
   ' Get the number of items
   ' ------------------------------------------
   p_lngNumItems = UBound(m_vntHeaders) + 1
On Error Resume Next
   p_lngNumRows = -1
   p_lngNumRows = UBound(m_vntData, 2) + 1
On Error GoTo 0

   ' ------------------------------------------
   ' Set the headers
   ' ------------------------------------------
   Me.ListView1.ColumnHeaders.Clear
   For p_lngLoop = 0 To (p_lngNumItems - 1)
      Me.ListView1.ColumnHeaders.Add Text:=m_vntHeaders(p_lngLoop)
   Next p_lngLoop

   ' ------------------------------------------
   ' Add the data
   ' ------------------------------------------
   If p_lngNumRows = -1 Then
      With Me.ListView1
         .Height = 900
         Me.cmdClose.Top = .Top + .Height + 150
         Me.Height = Me.cmdClose.Top + Me.cmdClose.Height + 480
      End With
      
      ' ------------------------------------
      ' Set the first column
      ' ------------------------------------
      p_strTmp = m_vntData(m_vntOrder(0))
      Set p_objListItem = Me.ListView1.ListItems.Add(Text:=p_strTmp)

      For p_lngLoop = 1 To p_lngNumItems - 1
         p_lngColData = m_vntOrder(p_lngLoop)
         
         ' ---------------------------------
         ' Set the rest of the columns
         ' ---------------------------------
         p_strTmp = m_vntData(p_lngColData)
         p_objListItem.SubItems(p_lngLoop) = p_strTmp
   
      Next p_lngLoop
      
   Else
      For p_lngLoop = 0 To (p_lngNumRows - 1)
         ' ------------------------------------
         ' Set the first column
         ' ------------------------------------
         p_strTmp = m_vntData(0, p_lngLoop)
         Set p_objListItem = Me.ListView1.ListItems.Add(Text:=p_strTmp)
   
         For p_lngInnerLoop = 1 To p_lngNumItems - 1
            p_lngColData = m_vntOrder(p_lngInnerLoop)
            
            ' ---------------------------------
            ' Set the rest of the columns
            ' ---------------------------------
            p_strTmp = m_vntData(p_lngColData, p_lngLoop)
            p_objListItem.SubItems(p_lngInnerLoop) = p_strTmp
      
         Next p_lngInnerLoop
      Next p_lngLoop
   End If
   
End Sub

Private Sub Form_Resize()
On Error Resume Next
   Dim p_lngLoop                       As Long
   
   Me.ListView1.Width = Me.ScaleWidth - 120
   Me.ListView1.Height = Me.ScaleHeight - 750
   Me.cmdClose.Left = Me.ScaleWidth - (Me.cmdClose.Width + 60)
   Me.cmdClose.Top = Me.ListView1.Top + Me.ListView1.Height + 120
   
   With Me.ListView1
      For p_lngLoop = 1 To .ColumnHeaders.Count
         .ColumnHeaders(p_lngLoop).Width = (.Width / .ColumnHeaders.Count)
      Next
   End With
   
End Sub

Private Sub InitListview()
   
   With Me.ListView1
      .FullRowSelect = True
      .GridLines = True
      .LabelEdit = lvwManual
      .MultiSelect = False
      .View = lvwReport
      .ListItems.Clear
      .SortKey = 0
      .Sorted = True
   End With
   
End Sub
