VERSION 5.00
Begin VB.Form frmLocalRemote 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Local and Remote Names"
   ClientHeight    =   2010
   ClientLeft      =   2400
   ClientTop       =   2085
   ClientWidth     =   3420
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2010
   ScaleWidth      =   3420
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   405
      Left            =   1238
      TabIndex        =   4
      Top             =   1470
      Width           =   945
   End
   Begin VB.TextBox txtRemoteName 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   1020
      Width           =   3225
   End
   Begin VB.TextBox txtLocalName 
      Height          =   285
      Left            =   120
      MaxLength       =   2
      TabIndex        =   0
      Top             =   360
      Width           =   315
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Remote Name (\\MyServer\MyShare):"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   780
      Width           =   2730
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Local Name (X:):"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   150
      Width           =   1185
   End
End
Attribute VB_Name = "frmLocalRemote"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_blnShowRemote                As Boolean
Private m_blnShowLocal                 As Boolean

Public Event ReturnData(ByVal LocalName As String, _
                        ByVal RemoteName As String)
                        
Public Sub Init(ByVal ShowRemote As Boolean, _
                ByVal ShowLocal As Boolean)
   m_blnShowRemote = ShowRemote
   m_blnShowLocal = ShowLocal
End Sub

Private Sub cmdOK_Click()
   Dim p_strTmp                        As String
   
   p_strTmp = UCase$(Me.txtLocalName.Text)
   If Len(p_strTmp) = 1 Then
      p_strTmp = p_strTmp & ":"
   End If
   
   If Right$(p_strTmp, 1) <> ":" Then
      p_strTmp = Left$(p_strTmp, 1) & ":"
   End If
   
   RaiseEvent ReturnData(p_strTmp, Me.txtRemoteName)
   
   Unload Me

End Sub

Private Sub Form_Load()
   
   modMain.CenterForm Me
   
   If m_blnShowRemote = False Then
      Me.Caption = "Local Name"
      Me.txtRemoteName.Visible = False
      Me.txtLocalName.Visible = True
      Me.Label1.Visible = True
      Me.Label2.Visible = False
      Me.cmdOK.Top = Me.cmdOK.Top - 500
   
   ElseIf m_blnShowLocal = False Then
      Me.Caption = "Remote Name"
      Me.txtRemoteName.Visible = True
      Me.txtLocalName.Visible = False
      Me.Label1.Visible = False
      Me.Label2.Visible = True
      Me.cmdOK.Top = Me.cmdOK.Top - 500
      Me.txtRemoteName.Top = Me.txtLocalName.Top
      Me.Label2.Top = Me.Label1.Top
   Else
      Me.Caption = "Local and Remote Names"
   End If

End Sub
