VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cEnumerations"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : cEnumerations.cls
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : Public non-creatable class
'           : Only for exposing enums to callers
' ---------------------------------------------
Option Explicit

Public Enum enmNameInfoLevel
   UNIVERSAL_NAME_INFO_LEVEL = &H1
   REMOTE_NAME_INFO_LEVEL = &H2
End Enum

Public Enum enmResourceType
   RESOURCEDISPLAYTYPE_GENERIC = &H0
   RESOURCEDISPLAYTYPE_DOMAIN = &H1
   RESOURCEDISPLAYTYPE_SERVER = &H2
   RESOURCEDISPLAYTYPE_SHARE = &H3
   RESOURCEDISPLAYTYPE_FILE = &H4
   RESOURCEDISPLAYTYPE_GROUP = &H5
   RESOURCEDISPLAYTYPE_ALL = -1
End Enum

Public Enum enmResources
   RemoteName = 0
   Comment = 1
   Provider = 2
   DisplayType = 3
   DisplayTypeText = 4
   Scope = 5
   ScopeText = 6
   ResType = 7
   ResTypeText = 8
End Enum

Public Enum enmNetInfo
   Characteristics = 0
   Drives = 1
   Printers = 2
   ProviderVersion = 3
   Status = 4
   StatusText = 5
   NetType = 6
   NetTypeText = 7
End Enum

Public Enum enmResourceInfo
   LocalName = 0
   RemoteName = 1
   Comment = 2
   Provider = 3
   Usage = 4
   UsageText = 5
   Scope = 6
   ScopeText = 7
   ResType = 8
   ResTypeText = 9
   DisplayType = 10
   DisplayTypeText = 11
End Enum

Public Enum enmNetInfoStatus
   NO_ERROR2 = 0&
   ERROR_NO_NETWORK = 1222&
   ERROR_BUSY = 170&
End Enum

Public Enum enmUniversalname
   UniveralName = 0
   ConnectionName = 1
   RemainingPath = 2
End Enum

Public Enum enmNetConnections
   UserName = 0
   Netname = 1
   ConnectID = 2
   ConnectTime = 3
   ConnectNumOpens = 4
   ConnectNumUses = 5
   ConnectType = 6
   ConnectTypeText = 7
End Enum
   
Public Enum enmFileEnum
   PathName = 0
   UserName = 1
   ID = 2
   NumLocks = 3
   Permissions = 4
   PermissionsText = 5
   ShareName = 6
End Enum

Public Enum enmServerInfo
   ServerName = 0
   Comment = 1
   ID = 2
   MajorVer = 3
   MinorVer = 4
   ServerType = 5
   ServerTypeText = 6
End Enum

Public Enum enmEnumSessions
   ClientForSession = 0
   UserName = 1
   ComputerForSession = 2
   Transport = 3
   IdleTime = 4
   NumOpens = 5
   TimeOpen = 6
   UserFlags = 7
   UserFlagsText = 8
   NumConnections = 9
End Enum

Public Enum enmSessionInfo
   ClientForSession = 0
   UserName = 1
   ComputerForSession = 2
   IdleTime = 3
   NumOpens = 4
   TimeOpen = 5
   UserFlags = 6
   UserFlagsText = 7
   NumConnects = 8
End Enum
      
Public Enum enmShareEnum
   Netname = 0
   Remark = 1
   Path = 2
   Password = 3
   MaxUses = 4
   CurrUses = 5
   ShareType = 6
   ShareTypeText = 7
   Permissions = 8
   PermissionsText = 9
End Enum

Public Enum enmCustErrors
   User_Cancelled = 1&
   Error_Invalid_OS = 2&
   Error_Invalid_Handle = 3&
   Error_NameTooLog = 4&
   Error_Wrong_Version = 100&
   ERROR_BAD_NET_NAME = 67&
   ERROR_NOT_AUTHENTICATED = 1244&
   ERROR_WNET_EXTENDED = 1208&
   ERROR_ACCESS_DENIED = 5&
End Enum
